var gMemotooThunderbird = null;
var gDossierId = "";

function loadSettings()
{
  document.getElementById("login").value = gMemotooThunderbird.settings.prefLogin;
  document.getElementById("password").value = gMemotooThunderbird.settings.prefPassword;
  document.getElementById("ssl").checked = gMemotooThunderbird.settings.prefSSL;
  initDossier(gMemotooThunderbird.settings.prefDossier);
  //document.getElementById("sync").checked = gMemotooThunderbird.settings.prefSyncOnLoad;
}

function saveSettings()
{
  gMemotooThunderbird.settings.prefLogin = document.getElementById("login").value;
  gMemotooThunderbird.settings.prefPassword = hex_md5(document.getElementById("password").value);
  gMemotooThunderbird.settings.prefSSL = document.getElementById("ssl").checked;
  //gMemotooThunderbird.settings.prefDossier = gDossierId;
  //gMemotooThunderbird.settings.prefSyncOnLoad = document.getElementById("sync").checked;
  //gMemotooThunderbird.settings.prefSyncOnExit = document.getElementById("sync").checked;
  gMemotooThunderbird.settings.prefIsUploader = false;
  gMemotooThunderbird.settings.prefIsDownloader = false;
}

function onLoad() 
{
  gMemotooThunderbird = new MemotooThunderbird();
  loadSettings();
}

function onSave() 
{
  saveSettings();
}

function initDossier(uri) 
{
  var count = opener.dirTree.view.rowCount;
	var vtigerABURL = "";
	var nsIndex = 0;
	var ncount = 0;
   for (var i = 0 ; i <= count-1; i++)
	{
		var res = opener.dirTree.builderView.getResourceAtIndex(i);
		var Aburl = res.Value;
		var RDF = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);

		// get the datasource for the addressdirectory
		var addressbookDS = RDF.GetDataSource("rdf:addressdirectory");
		
		// moz-abdirectory:// is the RDF root to get all types of addressbooks.
		var parentDir = RDF.GetResource("moz-abdirectory://").QueryInterface(Components.interfaces.nsIAbDirectory);
		
		// the RDF resource URI for LDAPDirectory will be like: "moz-abmdbdirectory://abook-3.mab"
		var ABdirectory = RDF.GetResource(Aburl).QueryInterface(Components.interfaces.nsIAbDirectory);
		
		// Copy existing dir type category id and mod time so they won't get reset.
		var ABProperties = ABdirectory.directoryProperties;
		
		var menupopelmnt = document.getElementById("expopup");	
		
		if(ABProperties.description!="")
		{
			var typechild = document.createElement('menuitem');
			typechild.setAttribute('label',ABProperties.description);
			typechild.setAttribute('value',Aburl);
			menupopelmnt.appendChild(typechild);
			if(Aburl == opener.gselecteddir)
			{
				nsIndex = ncount;
			}
			ncount = ncount + 1;
		}
	}
	document.getElementById('expablist').selectedIndex = nsIndex;
}

function browse()
{
  winopen("chrome://memotoothunderbird/content/browse.xul",250,360,1);
}

function download()
{
  saveSettings();
  
  var result = gMemotooThunderbird.downloadAddressBookLDIF();  
}

function upload()
{
  saveSettings();
  
  var result = gMemotooThunderbird.uploadAddressBookLDIF();  
}